// ---------------------------------
// Filename      : GeneralTools.h
// Author        : Sven Maerivoet
// Last modified : 25/08/2020
// Target        : C++ (Arduino UNO)
//
// All rights reserved.
// ---------------------------------

/*
  Copyright 2017, 2020 Sven Maerivoet

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
*/

#ifndef GENERALTOOLS_H
#define GENERALTOOLS_H

#include <AbstractToneGenerator.h>

#define cbi(sfr,bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#define sbi(sfr,bit) (_SFR_BYTE(sfr) |= _BV(bit))

void accelerateADCMeasurements();

#define getArraySize(x) (sizeof(x) / sizeof(x[0]))

void setRandomSeed(int analogPin);
void setRandomSeed();

byte getNonLinearPWMPercentageBased(double percentage);
byte getNonLinearPWM8BitBased(byte value);

void setPWMFrequency(int pin, int divisor);

long getVcc(AbstractToneGenerator* toneGenerator);
long getVcc();

void serialPrintIntegerVar(String description, int value);
void serialPrintDoubleVar(String description, double value);
void serialPrintBooleanVar(String description, bool value);

#endif
